package cn.ibizlab.assetmanagement.core.apply.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyState;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplyStateSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMApplyState] 服务对象接口
 */
public interface IEAMApplyStateService extends IService<EAMApplyState>{

    boolean create(EAMApplyState et) ;
    void createBatch(List<EAMApplyState> list) ;
    boolean update(EAMApplyState et) ;
    void updateBatch(List<EAMApplyState> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMApplyState get(String key) ;
    EAMApplyState getDraft(EAMApplyState et) ;
    boolean checkKey(EAMApplyState et) ;
    boolean save(EAMApplyState et) ;
    void saveBatch(List<EAMApplyState> list) ;
    Page<EAMApplyState> searchDefault(EAMApplyStateSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMApplyState> getEamapplystateByIds(List<String> ids) ;
    List<EAMApplyState> getEamapplystateByEntities(List<EAMApplyState> entities) ;
}


